<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Zonzay: optimization_oca_abstract.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="zonzay.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Zonzay
   &#160;<span id="projectnumber">1</span>
   </div>
   <div id="projectbrief">Laugh game challenge</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_f6486992fdfcc735347cc2d407578037.html">FaceFilterSDK</a></li><li class="navelem"><a class="el" href="dir_80a4fd4d67846ee877317f9ddd7282cb.html">DlibWrapper</a></li><li class="navelem"><a class="el" href="dir_9b7b8713e4f43f3006d0cb3c779d469e.html">dlib</a></li><li class="navelem"><a class="el" href="dir_b4000b80df5557ad6c393bb703a96248.html">optimization</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">optimization_oca_abstract.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">// Copyright (C) 2010  Davis E. King (davis@dlib.net)</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment">// License: Boost Software License   See LICENSE.txt for the full license.</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="preprocessor">#undef DLIB_OPTIMIZATION_OCA_ABsTRACT_Hh_</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="preprocessor">#ifdef DLIB_OPTIMIZATION_OCA_ABsTRACT_Hh_</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160; </div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160; </div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespacedlib.html">dlib</a></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;{</div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> matrix_type&gt;</div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;    <span class="keyword">class </span>oca_problem</div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;    {</div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;    <span class="keyword">public</span>:</div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160; </div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;        <span class="keyword">typedef</span> <span class="keyword">typename</span> matrix_type::type scalar_type;</div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160; </div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;        <span class="keyword">virtual</span> ~oca_problem() {}</div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160; </div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;        <span class="keyword">virtual</span> <span class="keywordtype">bool</span> risk_has_lower_bound (</div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;            scalar_type&amp; lower_bound</div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;        )<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="keyword">false</span>; }</div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;        <span class="keyword">virtual</span> <span class="keywordtype">bool</span> optimization_status (</div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;            scalar_type current_objective_value,</div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;            scalar_type current_error_gap,</div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;            scalar_type current_risk_value,</div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;            scalar_type current_risk_gap,</div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;            <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> num_cutting_planes,</div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;            <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> num_iterations</div><div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;        ) <span class="keyword">const</span> = 0;</div><div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;        <span class="keyword">virtual</span> scalar_type get_c (</div><div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;        ) <span class="keyword">const</span> = 0;</div><div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;        <span class="keyword">virtual</span> <span class="keywordtype">long</span> get_num_dimensions (</div><div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;        ) <span class="keyword">const</span> = 0;</div><div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;        <span class="keyword">virtual</span> <span class="keywordtype">void</span> get_risk (</div><div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;            matrix_type&amp; current_solution,</div><div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;            scalar_type&amp; risk_value,</div><div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;            matrix_type&amp; risk_subgradient</div><div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;        ) <span class="keyword">const</span> = 0;</div><div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;    };</div><div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160; </div><div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160; </div><div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;    <span class="keyword">class </span>oca</div><div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;    {</div><div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;    <span class="keyword">public</span>:</div><div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160; </div><div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;        oca (</div><div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;        ); </div><div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;        <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;            <span class="keyword">typename</span> matrix_type</div><div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;            &gt;</div><div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;        <span class="keyword">typename</span> matrix_type::type operator() (</div><div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;            <span class="keyword">const</span> oca_problem&lt;matrix_type&gt;&amp; problem,</div><div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;            matrix_type&amp; w,</div><div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;            <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> num_nonnegative = 0,</div><div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;            <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> force_weight_to_1 = std::numeric_limits&lt;unsigned long&gt;::max()</div><div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;        <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160;            <span class="keyword">typename</span> matrix_type</div><div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160;            &gt;</div><div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160;        <span class="keyword">typename</span> matrix_type::type operator() (</div><div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160;            <span class="keyword">const</span> oca_problem&lt;matrix_type&gt;&amp; problem,</div><div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160;            matrix_type&amp; w,</div><div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160;            <span class="keyword">const</span> matrix_type&amp; prior</div><div class="line"><a name="l00207"></a><span class="lineno">  207</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00224"></a><span class="lineno">  224</span>&#160;        <span class="keywordtype">void</span> set_subproblem_epsilon (</div><div class="line"><a name="l00225"></a><span class="lineno">  225</span>&#160;            <span class="keywordtype">double</span> eps</div><div class="line"><a name="l00226"></a><span class="lineno">  226</span>&#160;        ); </div><div class="line"><a name="l00234"></a><span class="lineno">  234</span>&#160;        <span class="keywordtype">double</span> get_subproblem_epsilon (</div><div class="line"><a name="l00235"></a><span class="lineno">  235</span>&#160;        ) <span class="keyword">const</span>; </div><div class="line"><a name="l00242"></a><span class="lineno">  242</span>&#160;        <span class="keywordtype">void</span> set_subproblem_max_iterations (</div><div class="line"><a name="l00243"></a><span class="lineno">  243</span>&#160;            <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> sub_max_iter</div><div class="line"><a name="l00244"></a><span class="lineno">  244</span>&#160;        ); </div><div class="line"><a name="l00252"></a><span class="lineno">  252</span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> get_subproblem_max_iterations (</div><div class="line"><a name="l00253"></a><span class="lineno">  253</span>&#160;        ) <span class="keyword">const</span>; </div><div class="line"><a name="l00260"></a><span class="lineno">  260</span>&#160;        <span class="keywordtype">void</span> set_inactive_plane_threshold (</div><div class="line"><a name="l00261"></a><span class="lineno">  261</span>&#160;            <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> inactive_thresh</div><div class="line"><a name="l00262"></a><span class="lineno">  262</span>&#160;        ); </div><div class="line"><a name="l00270"></a><span class="lineno">  270</span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> get_inactive_plane_threshold (</div><div class="line"><a name="l00271"></a><span class="lineno">  271</span>&#160;        ) <span class="keyword">const</span>; </div><div class="line"><a name="l00280"></a><span class="lineno">  280</span>&#160;    };</div><div class="line"><a name="l00281"></a><span class="lineno">  281</span>&#160;}</div><div class="line"><a name="l00282"></a><span class="lineno">  282</span>&#160; </div><div class="line"><a name="l00283"></a><span class="lineno">  283</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00284"></a><span class="lineno">  284</span>&#160; </div><div class="line"><a name="l00285"></a><span class="lineno">  285</span>&#160;<span class="preprocessor">#endif // DLIB_OPTIMIZATION_OCA_ABsTRACT_Hh_</span></div><div class="line"><a name="l00286"></a><span class="lineno">  286</span>&#160; </div><div class="line"><a name="l00287"></a><span class="lineno">  287</span>&#160; </div></div><!-- fragment --></div><!-- contents -->
<div class="ttc" id="anamespacedlib_html"><div class="ttname"><a href="namespacedlib.html">dlib</a></div><div class="ttdef"><b>Definition:</b> algs.h:119</div></div>
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.16
</small></address>
</body>
</html>
